#include "tap.h"
#include "TMSCommander.h"
#include "libFireBird.h"   //v1.0a, tested with FireBirdLib version "2010-11-14"

#define PGM_NAME        "BlackFrame4Vtx"
#define PGM_VERS        "V1.0a"
#define PGM_FULL        PGM_NAME " " PGM_VERS


TAP_ID( 0x81AFFE23 );
TAP_PROGRAM_NAME(PGM_NAME);
TAP_PROGRAM_VERSION(PGM_VERS);
TAP_AUTHOR_NAME("xyzzyx");
TAP_DESCRIPTION("A frame to make videotext completely black");
TAP_ETCINFO(__DATE__);


// TMSCommander_handler
static dword TMSCommander_handler(dword param1)
{
	switch (param1)
	{
		case TMSCMDR_Capabilities:
        return (dword)(TMSCMDR_CanBeStopped); //TMSCMDR_HaveMenu | TMSCMDR_CanBeStopped | TMSCMDR_HaveUserEvent);

	  case TMSCMDR_Menu:
		//call your TAP's menu
        return TMSCMDR_OK;

		case TMSCMDR_Stop:
		//Exit your TAP
        TAP_Exit();
        return TMSCMDR_OK;

		case TMSCMDR_UserEvent:
		//call your TAP's userevent
        return TMSCMDR_OK;

		case TMSCMDR_Exiting:
		//TMSCommander is exiting - do you want to do anything?
        return TMSCMDR_OK;

		default:
		//unknown TMSCommander function
        return TMSCMDR_UnknownFunction;
	}
}


dword TAP_EventHandler( word event, dword param1, dword param2 )
{
    UNUSED(param2);

    bool normal_state;
    dword state, subState;

    if (event == EVT_TMSCommander)
        return TMSCommander_handler(param1);

    TAP_GetState(&state, &subState);
    normal_state = (state == STATE_Normal && subState == SUBSTATE_Normal);

    if (event == EVT_KEY && param1 == RKEY_Teletext && normal_state)
    {
        TAP_Osd_FillBox(0, 0, 0, 720, 576, COLOR_Black);
        TAP_Osd_Sync();
    }
    if (event == EVT_KEY && param1 == RKEY_TvSat && state == STATE_Ttx)
    {
        TAP_Osd_FillBox(0, 0, 0, 720, 576, COLOR_None);
        TAP_Osd_Sync();
        TAP_Exit();
        return 0;
    }
    return param1;
}

int TAP_Main(void)
{
		KeyTranslate(TRUE, &TAP_EventHandler); //v1.0a
    return 1;
}


